QGIS Application - Feature request #6858
replace the vector query builder with the new expression builder
2012-12-11 07:27 AM - Giovanni Manghi

Status: Open

Priority: Normal

Assignee: Nathan Woodrow

Category: Vectors

Pull Request or Patch supplied: Resolution:

Easy fix?: No Copied to github as #: 15992
Description

Nathan | give this to you, but if it is not the case please remove yourself.

The new expression builder seems to have been added in many places (like for example in the WFS client, where anyway it doesn't
seems to be able to retrieve layer column values) but not in the vector query builder.

History

#1 - 2012-12-11 08:06 AM - Jiirgen Fischer
Must these be identical? Providers are not required to support the same syntax than QgsExpression. Some might use similar syntax, but aren't required to
match the functionality of QgsExpression (some might only support a subset (eg. OGR on shapes), some a superset (PostgreSQL) and some anything in
between). So the help in the expression builder is inaccurate and misleading and the interactive expression evaluation won't work there either.
#2 - 2012-12-11 08:13 AM - Giovanni Manghi
Jurgen Fischer wrote:
Must these be identical? Providers are not required to support the same syntax than QgsExpression. Some might use similar syntax, but aren't
required to match the functionality of QgsExpression (some might only support a subset (eg. OGR on shapes), some a superset (PostgreSQL) and

some anything in between). So the help in the expression builder is inaccurate and misleading and the interactive expression evaluation won't work
there either.

so0 maybe would be better to replace the query builder in the WFS client with the one available now in the vector properties?

#3 - 2012-12-11 08:17 AM - Giovanni Manghi

Giovanni Manghi wrote:

Jirgen Fischer wrote:
Must these be identical? Providers are not required to support the same syntax than QgsExpression. Some might use similar syntax, but aren't
required to match the functionality of QgsExpression (some might only support a subset (eg. OGR on shapes), some a superset (PostgreSQL) and

some anything in between). So the help in the expression builder is inaccurate and misleading and the interactive expression evaluation won't
work there either.

so maybe would be better to replace the query builder in the WFS client with the one available now in the vector properties?
or not, | remember that someone was working on adding spatial operators to the expression builder to allow use spatial relations to build queries. | guess it

needs the new expression builder.

Well... you devs known what is the right thing to do.

#4 - 2012-12-11 08:21 AM - Jiirgen Fischer

Giovanni Manghi wrote:

or not, | remember that someone was working on adding spatial operators to the expression builder to allow use spatial relations to build queries. |

guess it needs the new expression builder.

yes, the wfs client maps QgsExpressions to the OGC filter syntax - so using the expression builder is the right choice.

#5 - 2012-12-11 08:38 AM - Giovanni Manghi

Jurgen Fischer wrote:

Giovanni Manghi wrote:

or not, | remember that someone was working on adding spatial operators to the expression builder to allow use spatial relations to build queries. |

guess it needs the new expression builder.

yes, the wfs client maps QgsExpressions to the OGC filter syntax - so using the expression builder is the right choice.

If I'm not wrong the developer (rené-luc) was thinking to add this feature also the expression builder in the vector properties, not only in the wfs client, but
I'm not sure now.
#6 - 2012-12-18 07:51 PM - Nathan Woodrow
Jurgen Fischer wrote:
Must these be identical? Providers are not required to support the same syntax than QgsExpression. Some might use similar syntax, but aren't
required to match the functionality of QgsExpression (some might only support a subset (eg. OGR on shapes), some a superset (PostgreSQL) and

some anything in between). So the help in the expression builder is inaccurate and misleading and the interactive expression evaluation won't work

there either.

| agree this is the main issue. Something that | have considered is decoupling the expression builder from QgsExpression and allowing it to take just a set

of functions in a given format. This would allow us to pass provider functions into the Ul and have them listed like they currently are.

#7 - 2013-03-31 03:52 AM - Giovanni Manghi

The expression builder (with the new spatial function) it is now available in the table of attributes for selections, | guess that it makes even more sense now

to have it also to filter features in the query builder.
#8 - 2013-03-31 03:56 AM - Nathan Woodrow

@Giovanni not a simple task as they are different things. The attribute table is using QgsExpression while the Filter/Query option on the layer is using the
providers syntax. In order to support this QgsExpressionBuilder would need to be expanded to support plugable expression engines so that we could pass
it a list of functions for the different providers.

| can be done but it would take a bit of effort as you would have to build up a list of functions for each provider.

#9 - 2013-05-25 07:09 PM - Nathan Woodrow
- Priority changed from Normal to Low

- Target version changed from Version 2.0.0 to Future Release - Nice to have
#10 - 2014-06-20 06:52 AM - Giovanni Manghi
- Tracker changed from Bug report to Feature request

- Priority changed from Low to Normal

#11 - 2017-05-01 12:48 AM - Giovanni Manghi

- Easy fix? set to No
